#include <iostream>
#include <compare>

class sample
{
public:
    int num1;
    float num2;
    constexpr sample(int n1, float n2) : num1 { n1 }, num2 { n2 } { }
  
    auto operator<=>(const sample&) const = default;
};

int main()
{
    ::setlocale(LC_ALL, "");
  
    sample s1(1, 1.0f);
    sample s2(1, 2.0f);
  
    if(s1 < s2)
        std::cout << "s1 < s2" << std::endl;
  
    int a = 1; int b = 2;
  
    auto r1 = a <=> b;
  
    if (r1 == std::strong_ordering::less)
        std::cout << "a < b" << std::endl;
    else if (r1 == std::strong_ordering::greater)
        std::cout << "a > b" << std::endl;
    else if (r1 == std::strong_ordering::equal)
        std::cout << "a == b" << std::endl;
  
    return EXIT_SUCCESS;
}
